﻿Option Strict On
Imports System.Xml.Linq
Imports System.IO
Imports System.IO.IsolatedStorage
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Shared number As Integer = 1

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        Dim Index As Integer
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("PersonalInfo", "PersonalInfo.xml")
        If storage.FileExists(filePath) = True Then
            ichiranButton.IsEnabled = True
            Using stream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                Using reader As StreamReader = New StreamReader(stream, System.Text.Encoding.UTF8)
                    Dim readXmldoc As String = reader.ReadToEnd
                    Dim xmldoc As XElement = XElement.Parse(readXmldoc)
                    Dim getNumber As String = xmldoc.Descendants("情報").Elements("番号").Last.Value
                    number = Integer.Parse(getNumber) + 1
                    'reader.Dispose()
                    'stream.Dispose()
                End Using
            End Using

        Else
            ichiranButton.IsEnabled = False
        End If
        noTextBlock.Text = number.ToString

        Dim myParam As IDictionary(Of String, String) = NavigationContext.QueryString
        If myParam.ContainsKey("Index") = True Then
            Index = Integer.Parse(myParam("Index"))
            If Index < 0 Then Exit Sub
            Using myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                    Dim readXmldoc As String = reader.ReadToEnd
                    Dim doc As XElement = XElement.Parse(readXmldoc)
                    'reader.Dispose()
                    'myStream.Dispose()

                    noTextBlock.Text = doc.Descendants("情報")(Index).Element("番号").Value
                    nameTextBox.Text = doc.Descendants("情報")(Index).Element("氏名").Value
                    addressTextBox.Text = doc.Descendants("情報")(Index).Element("住所").Value
                    telTextBox.Text = doc.Descendants("情報")(Index).Element("電話").Value
                    mailTextBox.Text = doc.Descendants("情報")(Index).Element("E-mail").Value

                    saveButton1.IsEnabled = False
                    newButton.IsEnabled = True
                End Using
            End Using
            'editSaveButton.IsEnabled = True
        End If

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub saveButton1_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles saveButton1.Click
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("PersonalInfo") = False Then
            storage.CreateDirectory("PersonalInfo")
        End If
        Dim filePath As String = Path.Combine("PersonalInfo", "PersonalInfo.xml")
        If storage.FileExists(filePath) = False Then
            Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                      <個人情報>
                                          <情報>
                                              <番号><%= noTextBlock.Text %></番号>
                                              <氏名><%= nameTextBox.Text %></氏名>
                                              <住所><%= addressTextBox.Text %></住所>
                                              <電話><%= telTextBox.Text %></電話>
                                              <E-mail><%= mailTextBox.Text %></E-mail>
                                          </情報>
                                      </個人情報>

            Using stream As IsolatedStorageFileStream = storage.CreateFile(filePath)
            End Using
            'stream.Dispose()
            If storage.FileExists(filePath) = True Then
                Using writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
                    writer.Flush()
                    writer.Write(xmldoc.ToString)
                    'writer.Dispose()
                    MessageBox.Show("保存しました。")
                    ichiranButton.IsEnabled = True
                End Using
            End If
        Else
            Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
            Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                Dim readXmldoc As String = reader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim addXml As XElement = <情報>
                                             <番号><%= noTextBlock.Text %></番号>
                                             <氏名><%= nameTextBox.Text %></氏名>
                                             <住所><%= addressTextBox.Text %></住所>
                                             <電話><%= telTextBox.Text %></電話>
                                             <E-mail><%= mailTextBox.Text %></E-mail>
                                         </情報>

                doc.Add(addXml)
                'reader.Dispose()
                myStream.Close()

                If storage.FileExists(filePath) = True Then
                    Using writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
                        writer.Flush()
                        writer.Write(doc.ToString)
                        'writer.Close()
                        MessageBox.Show("保存しました。")
                    End Using
                End If
            End Using
        End If

        DataClear()
        number = number + 1
        noTextBlock.Text = number.ToString
    End Sub

    Private Sub DataClear()
        nameTextBox.Text = String.Empty
        addressTextBox.Text = String.Empty
        telTextBox.Text = String.Empty
        mailTextBox.Text = String.Empty

    End Sub

    Private Sub ichiranButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles ichiranButton.Click
        NavigationService.Navigate(New Uri("/DataIchiranPage.xaml", UriKind.Relative))
    End Sub

    'Private Sub editSaveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs)
    '    Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
    '    Dim filePath As String = Path.Combine("PersonalInfo", "PersonalInfo.xml")
    '    Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
    '    Dim reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)

    '    Dim readXmldoc As String = reader.ReadToEnd
    '    Dim doc As XElement = XElement.Parse(readXmldoc)
    '    reader.Dispose()
    '    myStream.Dispose()

    '    Dim addXml As XElement = <情報>
    '                                 <番号><%= noTextBlock.Text %></番号>
    '                                 <氏名><%= nameTextBox.Text %></氏名>
    '                                 <住所><%= addressTextBox.Text %></住所>
    '                                 <電話><%= telTextBox.Text %></電話>
    '                                 <E-mail><%= mailTextBox.Text %></E-mail>
    '                             </情報>
    '    doc.Descendants("情報")(Index).ReplaceWith(addXml)

    '    'doc.Descendants("情報")(Index).Element("氏名").Value = nameTextBox.Text
    '    'doc.Descendants("情報")(Index).Element("住所").Value = addressTextBox.Text
    '    'doc.Descendants("情報")(Index).Element("電話").Value = telTextBox.Text
    '    'doc.Descendants("情報")(Index).Element("E-mail").Value = mailTextBox.Text

    '    Dim stream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Write)

    '    'Dim stream As IsolatedStorageFileStream = New IsolatedStorageFileStream(filePath, FileMode.Open, FileAccess.Write, storage)
    '    doc.Save(stream)
    '    storage.Dispose()

    '    'streamを閉じるとXMLが整形式でなくなりエラーとなる。
    '    'streamを閉じなければアクセスできずエラーとなる。
    '    MessageBox.Show("編集保存しました。")
    '    doc = Nothing
    '    stream.Dispose()


    '    'Dim writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
    '    'writer.Flush()
    '    'writer.Write(doc.ToString)
    '    'writer.Close()

    'End Sub

    Private Sub cancelButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles cancelButton.Click
        DataClear()
    End Sub

    Private Sub newButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles newButton.Click
        NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
    End Sub
End Class
